#pragma once
#include <wx/wx.h>
#include <memory>
#include "git_repository.h"

class BranchSelector : public wxPanel {
public:
	BranchSelector(wxWindow* parent, std::shared_ptr<git::Repository> repo,
				 const wxString& label = wxEmptyString);

	bool SelectBranch(const wxString& branch_name);
	bool SelectGroupBranch(const wxString& group_name);
	std::string GetSelectedBranchName() const;
	bool ApplyBranchChange(bool hard_reset);

	std::shared_ptr<git::Repository> GetRepo() const { return repo_; }

private:
	void OnBranchSelected(wxCommandEvent& event);

	wxComboBox* branch_combo_ = nullptr;
	std::shared_ptr<git::Repository> repo_;
	wxString current_group_;

	wxDECLARE_EVENT_TABLE();
};
