#pragma once
#include <string>
#include <memory>
#include "SimpleIni.h"

class ConfigManager {
public:
	static ConfigManager& Instance();

	bool Load(const std::string& file_path = "repo.ini");
	bool Save(const std::string& file_path = "repo.ini");

	std::string GetRepositoryPath() const;
	void SetRepositoryPath(const std::string& path);

	bool GetHardReset() const;
	void SetHardReset(bool value);

	// 分支组操作
	void SaveBranchToGroup(const std::string& group_name, const std::string& repo_name, const std::string& branch_name);
	std::string GetBranchFromGroup(const std::string& group_name, const std::string& repo_name, const std::string& default_branch = "Develop", bool* found = nullptr);

private:
	ConfigManager() = default;
	~ConfigManager() = default;

	void InitializeDefaultConfig();

	CSimpleIniA ini_;

	// 禁止复制
	ConfigManager(const ConfigManager&) = delete;
	ConfigManager& operator=(const ConfigManager&) = delete;
};
